<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_131) on Mon Jul 17 12:51:54 CEST 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Entity (APP)</title>
<meta name="date" content="2017-07-17">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Entity (APP)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Entity.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../towerwarspp/board/BViewer.html" title="class in towerwarspp.board"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../towerwarspp/board/Hexagon.html" title="class in towerwarspp.board"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?towerwarspp/board/Entity.html" target="_top">Frames</a></li>
<li><a href="Entity.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">towerwarspp.board</div>
<h2 title="Class Entity" class="title">Class Entity</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>towerwarspp.board.Entity</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">Entity</span>
extends java.lang.Object</pre>
<div class="block">This class represents a token in the TowerWars game. Every <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object contains information about
 its current position on the board, height, possible moves, if it is blocked, and if it is a base (has height 0 and no possible moves).
 Each <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object representing a simple stone can become a tower. But if the object represents a base, the property of being a base
 can not be changed. Additionally, every <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> has information about the board size, the maximal allowed tower height,
 and the maximal possible step range.</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>15-07-2017</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Anastasiia Kysliak</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.util.Vector&lt;java.util.HashSet&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#allMoves">allMoves</a></span></code>
<div class="block">Contains all possible moves of this entity sorted according to the step range needed for reaching the end position.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#color">color</a></span></code>
<div class="block">The color of the Entity.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug">Debug</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#debug">debug</a></span></code>
<div class="block">Instance of the class <a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug"><code>Debug</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#height">height</a></span></code>
<div class="block">The height of the Entity.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#isBase">isBase</a></span></code>
<div class="block">Indicates if this entity is a base or not: if true, this entity is a base.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#isBlocked">isBlocked</a></span></code>
<div class="block">Shows whether the Entity is blocked or not.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#maxHeight">maxHeight</a></span></code>
<div class="block">The maximum allowed height.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#maxRange">maxRange</a></span></code>
<div class="block">The maximum step range which a token on the board of the given size can have.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#moveCounter">moveCounter</a></span></code>
<div class="block">counts, how many moves this entity has</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#position">position</a></span></code>
<div class="block">The Position of the Entity on the board.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#range">range</a></span></code>
<div class="block">Represents the current step range of the Entity.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#size">size</a></span></code>
<div class="block">The size of the board.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#Entity-towerwarspp.board.Entity-">Entity</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;original)</code>
<div class="block">Copy-Constructor: creates a new <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object which is a copy of the given <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object original.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#Entity-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-int-">Entity</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
      <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;color,
      int&nbsp;size)</code>
<div class="block">Constructor for the <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object.</div>
</td>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#Entity-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-int-boolean-">Entity</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
      <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;color,
      int&nbsp;size,
      boolean&nbsp;isBase)</code>
<div class="block">Constructor for for the <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object which has to be used in order to create a base:
 it allowes to set the variable isBase on true.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#addMove-towerwarspp.preset.Position-int-">addMove</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;end,
       int&nbsp;range)</code>
<div class="block">Creates a new move to the position end add adds it to all possible moves of this entity if there was no such move.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code><a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#clone--">clone</a></span>()</code>
<div class="block">Clones this <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> instance with the copy-constructor.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>private java.util.Vector&lt;java.util.HashSet&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#copyAllMoves--">copyAllMoves</a></span>()</code>
<div class="block">Returns collection of clones of all possible moves.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#decHeight--">decHeight</a></span>()</code>
<div class="block">Decreases the height of this entity by one.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#decRange--">decRange</a></span>()</code>
<div class="block">Decreases the step range of this entity by one and removes all moves
 which are not possible anymore</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#getColor--">getColor</a></span>()</code>
<div class="block">Returns the color of this entity.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#getHeight--">getHeight</a></span>()</code>
<div class="block">Returns the height of this entity.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#getMoveCounter--">getMoveCounter</a></span>()</code>
<div class="block">Returns the moveCounter.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>java.util.Vector&lt;java.util.HashSet&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#getMoves--">getMoves</a></span>()</code>
<div class="block">Returns a reference to the collection of all possible moves stored in this <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object (does not copy or restore the moves).</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>java.util.Vector&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#getMovesAsVector--">getMovesAsVector</a></span>()</code>
<div class="block">Returns all possible moves of this Entity stored in a vector.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code><a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#getPosition--">getPosition</a></span>()</code>
<div class="block">Returns the current position of this entity.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#getRange--">getRange</a></span>()</code>
<div class="block">Returns the current step range of this entity.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#hasMove-towerwarspp.preset.Position-int-">hasMove</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;end,
       int&nbsp;range)</code>
<div class="block">Returns true if this entity a move to the specified position.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#incHeight--">incHeight</a></span>()</code>
<div class="block">Increases the height of this entity by one.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#incRange--">incRange</a></span>()</code>
<div class="block">Increases the step range of this entity by one.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#initialiseMoves--">initialiseMoves</a></span>()</code>
<div class="block">Initializes the collection of all possible moves.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#isBase--">isBase</a></span>()</code>
<div class="block">Returns true if this entity is a base.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#isBlocked--">isBlocked</a></span>()</code>
<div class="block">Returns true if this entity is blocked.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#isMaxHeight--">isMaxHeight</a></span>()</code>
<div class="block">Returns true if this entity is a tower of the maximum height.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#isMovable--">isMovable</a></span>()</code>
<div class="block">Returns true if this entity can be moved.</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#isTower--">isTower</a></span>()</code>
<div class="block">Returns true if this entity is a tower.</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#removeAllMoves--">removeAllMoves</a></span>()</code>
<div class="block">Removes all moves from the collection of all possible moves and sets the range to 1.</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#removeMove-towerwarspp.preset.Position-int-">removeMove</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;end,
          int&nbsp;range)</code>
<div class="block">Removes the move to the specified position from the collection of all posiible moves if this entity had such move.</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#setBlocked-boolean-">setBlocked</a></span>(boolean&nbsp;blocked)</code>
<div class="block">Sets the Variable isBlocked to the specified value.</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Entity.html#setPosition-towerwarspp.preset.Position-">setPosition</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos)</code>
<div class="block">Changes the current position of this entity.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="color">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>color</h4>
<pre>private final&nbsp;<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a> color</pre>
<div class="block">The color of the Entity.</div>
</li>
</ul>
<a name="maxHeight">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>maxHeight</h4>
<pre>private final&nbsp;int maxHeight</pre>
<div class="block">The maximum allowed height.</div>
</li>
</ul>
<a name="maxRange">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>maxRange</h4>
<pre>private final&nbsp;int maxRange</pre>
<div class="block">The maximum step range which a token on the board of the given size can have.</div>
</li>
</ul>
<a name="position">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>position</h4>
<pre>private&nbsp;<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a> position</pre>
<div class="block">The Position of the Entity on the board.</div>
</li>
</ul>
<a name="height">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>height</h4>
<pre>private&nbsp;int height</pre>
<div class="block">The height of the Entity. If height == 0, this entity represents a normal stone. If height > 0, it is a tower.</div>
</li>
</ul>
<a name="isBlocked">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isBlocked</h4>
<pre>private&nbsp;boolean isBlocked</pre>
<div class="block">Shows whether the Entity is blocked or not.</div>
</li>
</ul>
<a name="range">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>range</h4>
<pre>private&nbsp;int range</pre>
<div class="block">Represents the current step range of the Entity.</div>
</li>
</ul>
<a name="allMoves">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>allMoves</h4>
<pre>private&nbsp;java.util.Vector&lt;java.util.HashSet&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;&gt; allMoves</pre>
<div class="block">Contains all possible moves of this entity sorted according to the step range needed for reaching the end position.
 This means: the position n in the Vector contains a reference to the HashSet where all possible moves of the range n are stored.</div>
</li>
</ul>
<a name="size">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>size</h4>
<pre>private&nbsp;int size</pre>
<div class="block">The size of the board.</div>
</li>
</ul>
<a name="isBase">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isBase</h4>
<pre>private&nbsp;boolean isBase</pre>
<div class="block">Indicates if this entity is a base or not: if true, this entity is a base.</div>
</li>
</ul>
<a name="moveCounter">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>moveCounter</h4>
<pre>private&nbsp;int moveCounter</pre>
<div class="block">counts, how many moves this entity has</div>
</li>
</ul>
<a name="debug">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>debug</h4>
<pre>private&nbsp;<a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug">Debug</a> debug</pre>
<div class="block">Instance of the class <a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug"><code>Debug</code></a>.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Entity-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Entity</h4>
<pre>public&nbsp;Entity(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
              <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;color,
              int&nbsp;size)</pre>
<div class="block">Constructor for the <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object. creates a new Entity which represents a stone: has the height 0 and the range 1.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>pos</code> - the current position of this token.</dd>
<dd><code>color</code> - the color of this token.</dd>
<dd><code>size</code> - the size of the board on which this token will be used for the TowerWars game.</dd>
</dl>
</li>
</ul>
<a name="Entity-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-int-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Entity</h4>
<pre>public&nbsp;Entity(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
              <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;color,
              int&nbsp;size,
              boolean&nbsp;isBase)</pre>
<div class="block">Constructor for for the <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object which has to be used in order to create a base:
 it allowes to set the variable isBase on true.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>pos</code> - the current position of this token.</dd>
<dd><code>color</code> - the color of this token.</dd>
<dd><code>size</code> - the size of the board on which this token will be used for the TowerWars game.</dd>
<dd><code>isBase</code> - defines if the new token has to be a base or a normal stone.</dd>
</dl>
</li>
</ul>
<a name="Entity-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Entity</h4>
<pre>public&nbsp;Entity(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;original)</pre>
<div class="block">Copy-Constructor: creates a new <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object which is a copy of the given <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object original.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>original</code> - <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object which has to be copied.</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getPosition--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPosition</h4>
<pre>public&nbsp;<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;getPosition()</pre>
<div class="block">Returns the current position of this entity.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the current position of this entity.</dd>
</dl>
</li>
</ul>
<a name="setPosition-towerwarspp.preset.Position-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setPosition</h4>
<pre>public&nbsp;void&nbsp;setPosition(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos)</pre>
<div class="block">Changes the current position of this entity.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>pos</code> - the new position.</dd>
</dl>
</li>
</ul>
<a name="getColor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getColor</h4>
<pre>public&nbsp;<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;getColor()</pre>
<div class="block">Returns the color of this entity.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the color of this entity.</dd>
</dl>
</li>
</ul>
<a name="getHeight--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getHeight</h4>
<pre>public&nbsp;int&nbsp;getHeight()</pre>
<div class="block">Returns the height of this entity.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the height of this entity.</dd>
</dl>
</li>
</ul>
<a name="getRange--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getRange</h4>
<pre>public&nbsp;int&nbsp;getRange()</pre>
<div class="block">Returns the current step range of this entity.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the current step range of this entity.</dd>
</dl>
</li>
</ul>
<a name="getMoves--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMoves</h4>
<pre>public&nbsp;java.util.Vector&lt;java.util.HashSet&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;&gt;&nbsp;getMoves()</pre>
<div class="block">Returns a reference to the collection of all possible moves stored in this <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object (does not copy or restore the moves).</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a reference to the collection of all possible moves stored in this <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> object.</dd>
</dl>
</li>
</ul>
<a name="getMovesAsVector--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMovesAsVector</h4>
<pre>public&nbsp;java.util.Vector&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;&nbsp;getMovesAsVector()</pre>
<div class="block">Returns all possible moves of this Entity stored in a vector.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>all possible moves of this Entity stored in a vector.</dd>
</dl>
</li>
</ul>
<a name="isBlocked--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isBlocked</h4>
<pre>public&nbsp;boolean&nbsp;isBlocked()</pre>
<div class="block">Returns true if this entity is blocked.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if this entity is blocked.</dd>
</dl>
</li>
</ul>
<a name="setBlocked-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setBlocked</h4>
<pre>public&nbsp;void&nbsp;setBlocked(boolean&nbsp;blocked)</pre>
<div class="block">Sets the Variable isBlocked to the specified value.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>blocked</code> - defines if this entity representing a tower has to be blocked or unblocked.</dd>
</dl>
</li>
</ul>
<a name="isBase--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isBase</h4>
<pre>public&nbsp;boolean&nbsp;isBase()</pre>
<div class="block">Returns true if this entity is a base.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if this entity is a base.</dd>
</dl>
</li>
</ul>
<a name="getMoveCounter--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMoveCounter</h4>
<pre>public&nbsp;int&nbsp;getMoveCounter()</pre>
<div class="block">Returns the moveCounter.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>moveCounter.</dd>
</dl>
</li>
</ul>
<a name="isTower--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isTower</h4>
<pre>public&nbsp;boolean&nbsp;isTower()</pre>
<div class="block">Returns true if this entity is a tower.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if this entity is a tower (its height > 0).</dd>
</dl>
</li>
</ul>
<a name="isMaxHeight--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isMaxHeight</h4>
<pre>public&nbsp;boolean&nbsp;isMaxHeight()</pre>
<div class="block">Returns true if this entity is a tower of the maximum height.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if this entity is a tower of the maximum height.</dd>
</dl>
</li>
</ul>
<a name="isMovable--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isMovable</h4>
<pre>public&nbsp;boolean&nbsp;isMovable()</pre>
<div class="block">Returns true if this entity can be moved. This means: this entity is not a base, not blocked and has at least one possible move.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if this entity can be moved.</dd>
</dl>
</li>
</ul>
<a name="hasMove-towerwarspp.preset.Position-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasMove</h4>
<pre>public&nbsp;boolean&nbsp;hasMove(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;end,
                       int&nbsp;range)</pre>
<div class="block">Returns true if this entity a move to the specified position.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>end</code> - position of the move in question.</dd>
<dd><code>range</code> - distance to the move's end position from the current position of this entity.</dd>
</dl>
</li>
</ul>
<a name="incHeight--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>incHeight</h4>
<pre>public&nbsp;void&nbsp;incHeight()</pre>
<div class="block">Increases the height of this entity by one.</div>
</li>
</ul>
<a name="decHeight--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decHeight</h4>
<pre>public&nbsp;void&nbsp;decHeight()</pre>
<div class="block">Decreases the height of this entity by one.</div>
</li>
</ul>
<a name="decRange--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decRange</h4>
<pre>public&nbsp;void&nbsp;decRange()</pre>
<div class="block">Decreases the step range of this entity by one and removes all moves
 which are not possible anymore</div>
</li>
</ul>
<a name="incRange--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>incRange</h4>
<pre>public&nbsp;void&nbsp;incRange()</pre>
<div class="block">Increases the step range of this entity by one. The newly possible moves have to be added extra.</div>
</li>
</ul>
<a name="addMove-towerwarspp.preset.Position-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addMove</h4>
<pre>public&nbsp;void&nbsp;addMove(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;end,
                    int&nbsp;range)</pre>
<div class="block">Creates a new move to the position end add adds it to all possible moves of this entity if there was no such move.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>end</code> - end position of the move in question.</dd>
<dd><code>range</code> - distance to the move's end position from the current position of this entity.</dd>
</dl>
</li>
</ul>
<a name="removeMove-towerwarspp.preset.Position-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeMove</h4>
<pre>public&nbsp;void&nbsp;removeMove(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;end,
                       int&nbsp;range)</pre>
<div class="block">Removes the move to the specified position from the collection of all posiible moves if this entity had such move.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>end</code> - end position of the move in question.</dd>
<dd><code>range</code> - distance to the move's end position from the current position of this entity.</dd>
</dl>
</li>
</ul>
<a name="removeAllMoves--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeAllMoves</h4>
<pre>public&nbsp;void&nbsp;removeAllMoves()</pre>
<div class="block">Removes all moves from the collection of all possible moves and sets the range to 1.</div>
</li>
</ul>
<a name="copyAllMoves--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>copyAllMoves</h4>
<pre>private&nbsp;java.util.Vector&lt;java.util.HashSet&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;&gt;&nbsp;copyAllMoves()</pre>
<div class="block">Returns collection of clones of all possible moves.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>collection of clones of all possible moves.</dd>
</dl>
</li>
</ul>
<a name="initialiseMoves--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>initialiseMoves</h4>
<pre>private&nbsp;void&nbsp;initialiseMoves()</pre>
<div class="block">Initializes the collection of all possible moves.</div>
</li>
</ul>
<a name="clone--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>clone</h4>
<pre>public&nbsp;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;clone()</pre>
<div class="block">Clones this <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board"><code>Entity</code></a> instance with the copy-constructor.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code>clone</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the clone of this entity.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Entity.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../towerwarspp/board/BViewer.html" title="class in towerwarspp.board"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../towerwarspp/board/Hexagon.html" title="class in towerwarspp.board"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?towerwarspp/board/Entity.html" target="_top">Frames</a></li>
<li><a href="Entity.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
